/*
  LiquidCrystal Library - Hello World
 
 Demonstrates the use a 16x2 LCD display.  The LiquidCrystal
 library works with all LCD displays that are compatible with the 
 Hitachi HD44780 driver. There are many of them out there, and you
 can usually tell them by the 16-pin interface.
 
 Ce programme gère l'affichage de la bobineuse et la gestion moteur
 Affiche sur l'écran LCD le nombre de spires
 Gère l'avance du moteur pàp en fonction du diamètre
 
 Le circuit:
 * ILS 1 to digital pin 2
 * ILS 2 to digital pin 3
 * LCD RS pin to digital pin 12
 * LCD Enable pin to digital pin 11
 * LCD D4 pin to digital pin 6
 * LCD D5 pin to digital pin 8
 * LCD D6 pin to digital pin 9
 * LCD D7 pin to digital pin 10
 * LCD R/W pin to ground
 * 10K resistor:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)
 
 Library originally added 18 Apr 2008
 by David A. Mellis
 library modified 5 Jul 2009
 by Limor Fried (http://www.ladyada.net)
 example added 9 Jul 2009
 by Tom Igoe
 modified 22 Nov 2010
 by Tom Igoe
 
 This example code is in the public domain.
 
 http://www.arduino.cc/en/Tutorial/LiquidCrystal
 */

// include the library code:
#include <LiquidCrystal.h>

// Définition des PIN
// pin 2 = int1
#define ILS_A  2  
// pin 3 = int0
#define ILS_B  3  

// Définition des variables
// Mémorise l'état des sorties A et B
int CountUp = 0; 
int CountDown = 0;

int Compteur = 0;

// Mémoreise le diamètre du fil
float Dfil = 0;

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 10, 9, 8, 6);


void setup() {
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  // Print a message to the LCD.
  lcd.print("Compteur");
  // (note: line 1 is the second line, since counting begins with 0):
  lcd.setCursor(12,0);
  lcd.print(Compteur);
  // Initialise les entrées A et B
  pinMode(ILS_A, INPUT); 
  pinMode(ILS_B, INPUT); 
  attachInterrupt(1, GestionInterruptionILS_A, HIGH);
 
}

void loop() {
  
      while(CountUp==1) // CW motion 
      {
       CountUp=0; // Reset the flag
       Compteur++;
      }

      while(CountDown==1) // CCW 
      {
       CountDown=0; // clear the flag
       Compteur--;
      }
     
    // set the cursor to column 12, line 0
    // (note: line 1 is the second row, since counting begins with 0):
    lcd.setCursor(12,0);
    // reset the screen:
    lcd.print("    ");
    // set the cursor to column 12, line 0
    lcd.setCursor(12,0);
    lcd.print(Compteur/2);
    
    
    Dfil = 0.215;
    // set the cursor to column 0, line 1
    // (note: line 1 is the second row, since counting begins with 0):
    lcd.setCursor(0,1);
    // print the number of seconds since reset:
    lcd.print("Diam fil");
    // set the cursor to column 0, line 1
    // (note: line 1 is the second row, since counting begins with 0):
    lcd.setCursor(11,1);
    lcd.print(Dfil,4); 
}

// Routine de service d'interruption attachée à la voie A de la bobineuse
void GestionInterruptionILS_A()
{
  delay(10);
  if (digitalRead(ILS_B) == digitalRead(ILS_A)) {
    CountDown=1;
  }
  else {
   CountUp=1; 
  }
}





